diff --git a/contrib/pgcrypto/imath.c b/contrib/pgcrypto/imath.c
index b94a51b..96be668 100644
--- a/contrib/pgcrypto/imath.c
+++ b/contrib/pgcrypto/imath.c
@@ -874,45 +887,39 @@ mp_int_mul_value(mp_int a, int value, mp_int c)
 	return mp_int_mul(a, &vtmp, c);
 }
 
-/* }}} */
-
-/* {{{ mp_int_mul_pow2(a, p2, c) */
-
 mp_result
-mp_int_mul_pow2(mp_int a, int p2, mp_int c)
+mp_int_mul_pow2(mp_int a, mp_small p2, mp_int c)
 {
-	mp_result	res;
+	assert(a != NULL && c != NULL && p2 >= 0);
 
-	CHECK(a != NULL && c != NULL && p2 >= 0);
+	mp_result	res = mp_int_copy(a, c);
 
-	if ((res = mp_int_copy(a, c)) != MP_OK)
+	if (res != MP_OK)
 		return res;
 
 	if (s_qmul(c, (mp_size) p2))
+	{
 		return MP_OK;
+	}
 	else
+	{
 		return MP_MEMORY;
+	}
 }
 
-/* }}} */
-
-/* {{{ mp_int_sqr(a, c) */
-
 mp_result
 mp_int_sqr(mp_int a, mp_int c)
 {
-	mp_digit   *out;
-	mp_size		osize,
-				p = 0;
-
-	CHECK(a != NULL && c != NULL);
+	assert(a != NULL && c != NULL);
 
 	/* Get a temporary buffer big enough to hold the result */
-	osize = (mp_size) 4 * ((MP_USED(a) + 1) / 2);
+	mp_size		osize = (mp_size) 4 * ((MP_USED(a) + 1) / 2);
+	mp_size		p = 0;
+	mp_digit   *out;
 
 	if (a == c)
 	{
-		p = ROUND_PREC(osize);
+		p = s_round_prec(osize);
 		p = MAX(p, default_precision);
 
 		if ((out = s_alloc(p)) == NULL)
@@ -935,39 +942,35 @@ mp_int_sqr(mp_int a, mp_int c)
 	 */
 	if (out != MP_DIGITS(c))
 	{
-		s_free(MP_DIGITS(c));
-		MP_DIGITS(c) = out;
-		MP_ALLOC(c) = p;
+		if ((void *) MP_DIGITS(c) != (void *) c)
+			s_free(MP_DIGITS(c));
+		c->digits = out;
+		c->alloc = p;
 	}
 
-	MP_USED(c) = osize;			/* might not be true, but we'll fix it ... */
+	c->used = osize;			/* might not be true, but we'll fix it ... */
 	CLAMP(c);					/* ... right here */
-	MP_SIGN(c) = MP_ZPOS;
+	c->sign = MP_ZPOS;
 
 	return MP_OK;
 }
 
-/* }}} */
-
-/* {{{ mp_int_div(a, b, q, r) */
-
 mp_result
 mp_int_div(mp_int a, mp_int b, mp_int q, mp_int r)
 {
-	int			cmp,
-				last = 0,
-				lg;
+	assert(a != NULL && b != NULL && q != r);
+
+	int			cmp;
 	mp_result	res = MP_OK;
-	mpz_t		temp[2];
 	mp_int		qout,
 				rout;
-	mp_sign		sa = MP_SIGN(a),
-				sb = MP_SIGN(b);
-
-	CHECK(a != NULL && b != NULL && q != r);
+	mp_sign		sa = MP_SIGN(a);
+	mp_sign		sb = MP_SIGN(b);
 
 	if (CMPZ(b) == 0)
+	{
 		return MP_UNDEF;
+	}
 	else if ((cmp = s_ucmp(a, b)) < 0)
 	{
 		/*
@@ -995,7 +998,7 @@ mp_int_div(mp_int a, mp_int b, mp_int q, mp_int r)
 			q->digits[0] = 1;
 
 			if (sa != sb)
-				MP_SIGN(q) = MP_NEG;
+				q->sign = MP_NEG;
 		}
 
 		return MP_OK;
@@ -1006,37 +1009,41 @@ mp_int_div(mp_int a, mp_int b, mp_int q, mp_int r)
 	 * quotient and remainder, but q and r are allowed to be NULL or to
 	 * overlap with the inputs.
 	 */
+	DECLARE_TEMP(2);
+	int			lg;
+
 	if ((lg = s_isp2(b)) < 0)
 	{
-		if (q && b != q && (res = mp_int_copy(a, q)) == MP_OK)
+		if (q && b != q)
 		{
+			REQUIRE(mp_int_copy(a, q));
 			qout = q;
 		}
 		else
 		{
-			qout = TEMP(last);
-			SETUP(mp_int_init_copy(TEMP(last), a), last);
+			REQUIRE(mp_int_copy(a, TEMP(0)));
+			qout = TEMP(0);
 		}
 
-		if (r && a != r && (res = mp_int_copy(b, r)) == MP_OK)
+		if (r && a != r)
 		{
+			REQUIRE(mp_int_copy(b, r));
 			rout = r;
 		}
 		else
 		{
-			rout = TEMP(last);
-			SETUP(mp_int_init_copy(TEMP(last), b), last);
+			REQUIRE(mp_int_copy(b, TEMP(1)));
+			rout = TEMP(1);
 		}
 
-		if ((res = s_udiv(qout, rout)) != MP_OK)
-			goto CLEANUP;
+		REQUIRE(s_udiv_knuth(qout, rout));
 	}
 	else
 	{
-		if (q && (res = mp_int_copy(a, q)) != MP_OK)
-			goto CLEANUP;
-		if (r && (res = mp_int_copy(a, r)) != MP_OK)
-			goto CLEANUP;
+		if (q)
+			REQUIRE(mp_int_copy(a, q));
+		if (r)
+			REQUIRE(mp_int_copy(a, r));
 
 		if (q)
 			s_qdiv(q, (mp_size) lg);
@@ -1049,203 +1056,184 @@ mp_int_div(mp_int a, mp_int b, mp_int q, mp_int r)
 	/* Recompute signs for output */
 	if (rout)
 	{
-		MP_SIGN(rout) = sa;
+		rout->sign = sa;
 		if (CMPZ(rout) == 0)
-			MP_SIGN(rout) = MP_ZPOS;
+			rout->sign = MP_ZPOS;
 	}
 	if (qout)
 	{
-		MP_SIGN(qout) = (sa == sb) ? MP_ZPOS : MP_NEG;
+		qout->sign = (sa == sb) ? MP_ZPOS : MP_NEG;
 		if (CMPZ(qout) == 0)
-			MP_SIGN(qout) = MP_ZPOS;
+			qout->sign = MP_ZPOS;
 	}
 
-	if (q && (res = mp_int_copy(qout, q)) != MP_OK)
-		goto CLEANUP;
-	if (r && (res = mp_int_copy(rout, r)) != MP_OK)
-		goto CLEANUP;
-
-CLEANUP:
-	while (--last >= 0)
-		mp_int_clear(TEMP(last));
-
+	if (q)
+		REQUIRE(mp_int_copy(qout, q));
+	if (r)
+		REQUIRE(mp_int_copy(rout, r));
+	CLEANUP_TEMP();
 	return res;
 }
 
-/* }}} */
-
-/* {{{ mp_int_mod(a, m, c) */
-
 mp_result
 mp_int_mod(mp_int a, mp_int m, mp_int c)
 {
-	mp_result	res;
-	mpz_t		tmp;
-	mp_int		out;
+	DECLARE_TEMP(1);
+	mp_int		out = (m == c) ? TEMP(0) : c;
 
-	if (m == c)
+	REQUIRE(mp_int_div(a, m, NULL, out));
+	if (CMPZ(out) < 0)
 	{
-		if ((res = mp_int_init(&tmp)) != MP_OK)
-			return res;
-
-		out = &tmp;
+		REQUIRE(mp_int_add(out, m, c));
 	}
 	else
 	{
-		out = c;
+		REQUIRE(mp_int_copy(out, c));
 	}
-
-	if ((res = mp_int_div(a, m, NULL, out)) != MP_OK)
-		goto CLEANUP;
-
-	if (CMPZ(out) < 0)
-		res = mp_int_add(out, m, c);
-	else
-		res = mp_int_copy(out, c);
-
-CLEANUP:
-	if (out != c)
-		mp_int_clear(&tmp);
-
-	return res;
+	CLEANUP_TEMP();
+	return MP_OK;
 }
 
-/* }}} */
-
-
-/* {{{ mp_int_div_value(a, value, q, r) */
-
 mp_result
-mp_int_div_value(mp_int a, int value, mp_int q, int *r)
+mp_int_div_value(mp_int a, mp_small value, mp_int q, mp_small * r)
 {
-	mpz_t		vtmp,
-				rtmp;
+	mpz_t		vtmp;
 	mp_digit	vbuf[MP_VALUE_DIGITS(value)];
-	mp_result	res;
 
-	if ((res = mp_int_init(&rtmp)) != MP_OK)
-		return res;
 	s_fake(&vtmp, value, vbuf);
 
-	if ((res = mp_int_div(a, &vtmp, q, &rtmp)) != MP_OK)
-		goto CLEANUP;
+	DECLARE_TEMP(1);
+	REQUIRE(mp_int_div(a, &vtmp, q, TEMP(0)));
 
 	if (r)
-		(void) mp_int_to_int(&rtmp, r); /* can't fail */
+		(void) mp_int_to_int(TEMP(0), r);	/* can't fail */
 
-CLEANUP:
-	mp_int_clear(&rtmp);
-	return res;
+	CLEANUP_TEMP();
+	return MP_OK;
 }
 
-/* }}} */
-
-/* {{{ mp_int_div_pow2(a, p2, q, r) */
-
 mp_result
-mp_int_div_pow2(mp_int a, int p2, mp_int q, mp_int r)
+mp_int_div_pow2(mp_int a, mp_small p2, mp_int q, mp_int r)
 {
-	mp_result	res = MP_OK;
+	assert(a != NULL && p2 >= 0 && q != r);
 
-	CHECK(a != NULL && p2 >= 0 && q != r);
+	mp_result	res = MP_OK;
 
 	if (q != NULL && (res = mp_int_copy(a, q)) == MP_OK)
+	{
 		s_qdiv(q, (mp_size) p2);
+	}
 
 	if (res == MP_OK && r != NULL && (res = mp_int_copy(a, r)) == MP_OK)
+	{
 		s_qmod(r, (mp_size) p2);
+	}
 
 	return res;
 }
 
-/* }}} */
-
-/* {{{ mp_int_expt(a, b, c) */
-
 mp_result
-mp_int_expt(mp_int a, int b, mp_int c)
+mp_int_expt(mp_int a, mp_small b, mp_int c)
 {
-	mpz_t		t;
-	mp_result	res;
-	unsigned int v = abs(b);
+	assert(c != NULL);
+	if (b < 0)
+		return MP_RANGE;
 
-	CHECK(b >= 0 && c != NULL);
-
-	if ((res = mp_int_init_copy(&t, a)) != MP_OK)
-		return res;
+	DECLARE_TEMP(1);
+	REQUIRE(mp_int_copy(a, TEMP(0)));
 
 	(void) mp_int_set_value(c, 1);
+	unsigned int v = labs(b);
+
 	while (v != 0)
 	{
 		if (v & 1)
 		{
-			if ((res = mp_int_mul(c, &t, c)) != MP_OK)
-				goto CLEANUP;
+			REQUIRE(mp_int_mul(c, TEMP(0), c));
 		}
 
 		v >>= 1;
 		if (v == 0)
 			break;
 
-		if ((res = mp_int_sqr(&t, &t)) != MP_OK)
-			goto CLEANUP;
+		REQUIRE(mp_int_sqr(TEMP(0), TEMP(0)));
 	}
 
-CLEANUP:
-	mp_int_clear(&t);
-	return res;
+	CLEANUP_TEMP();
+	return MP_OK;
 }
 
-/* }}} */
-
-/* {{{ mp_int_expt_value(a, b, c) */
-
 mp_result
-mp_int_expt_value(int a, int b, mp_int c)
+mp_int_expt_value(mp_small a, mp_small b, mp_int c)
 {
-	mpz_t		t;
-	mp_result	res;
-	unsigned int v = abs(b);
-
-	CHECK(b >= 0 && c != NULL);
+	assert(c != NULL);
+	if (b < 0)
+		return MP_RANGE;
 
-	if ((res = mp_int_init_value(&t, a)) != MP_OK)
-		return res;
+	DECLARE_TEMP(1);
+	REQUIRE(mp_int_set_value(TEMP(0), a));
 
 	(void) mp_int_set_value(c, 1);
+	unsigned int v = labs(b);
+
 	while (v != 0)
 	{
 		if (v & 1)
 		{
-			if ((res = mp_int_mul(c, &t, c)) != MP_OK)
-				goto CLEANUP;
+			REQUIRE(mp_int_mul(c, TEMP(0), c));
 		}
 
 		v >>= 1;
 		if (v == 0)
 			break;
 
-		if ((res = mp_int_sqr(&t, &t)) != MP_OK)
-			goto CLEANUP;
+		REQUIRE(mp_int_sqr(TEMP(0), TEMP(0)));
 	}
 
-CLEANUP:
-	mp_int_clear(&t);
-	return res;
+	CLEANUP_TEMP();
+	return MP_OK;
 }
 
-/* }}} */
+mp_result
+mp_int_expt_full(mp_int a, mp_int b, mp_int c)
+{
+	assert(a != NULL && b != NULL && c != NULL);
+	if (MP_SIGN(b) == MP_NEG)
+		return MP_RANGE;
+
+	DECLARE_TEMP(1);
+	REQUIRE(mp_int_copy(a, TEMP(0)));
+
+	(void) mp_int_set_value(c, 1);
+	for (unsigned ix = 0; ix < MP_USED(b); ++ix)
+	{
+		mp_digit	d = b->digits[ix];
+
+		for (unsigned jx = 0; jx < MP_DIGIT_BIT; ++jx)
+		{
+			if (d & 1)
+			{
+				REQUIRE(mp_int_mul(c, TEMP(0), c));
+			}
+
+			d >>= 1;
+			if (d == 0 && ix + 1 == MP_USED(b))
+				break;
+			REQUIRE(mp_int_sqr(TEMP(0), TEMP(0)));
+		}
+	}
 
-/* {{{ mp_int_compare(a, b) */
+	CLEANUP_TEMP();
+	return MP_OK;
+}
 
 int
 mp_int_compare(mp_int a, mp_int b)
 {
-	mp_sign		sa;
+	assert(a != NULL && b != NULL);
 
-	CHECK(a != NULL && b != NULL);
+	mp_sign		sa = MP_SIGN(a);
 
-	sa = MP_SIGN(a);
 	if (sa == MP_SIGN(b))
 	{
 		int			cmp = s_ucmp(a, b);
@@ -1254,91 +1242,90 @@ mp_int_compare(mp_int a, mp_int b)
 		 * If they're both zero or positive, the normal comparison applies; if
 		 * both negative, the sense is reversed.
 		 */
-		if (sa != MP_ZPOS)
-			INVERT_COMPARE_RESULT(cmp);
-		return cmp;
+		if (sa == MP_ZPOS)
+		{
+			return cmp;
+		}
+		else
+		{
+			return -cmp;
+		}
+	}
+	else if (sa == MP_ZPOS)
+	{
+		return 1;
 	}
 	else
 	{
-		if (sa == MP_ZPOS)
-			return 1;
-		else
-			return -1;
+		return -1;
 	}
 }
 
-/* }}} */
-
-/* {{{ mp_int_compare_unsigned(a, b) */
-
 int
 mp_int_compare_unsigned(mp_int a, mp_int b)
 {
-	NRCHECK(a != NULL && b != NULL);
+	assert(a != NULL && b != NULL);
 
 	return s_ucmp(a, b);
 }
 
-/* }}} */
-
-/* {{{ mp_int_compare_zero(z) */
-
 int
 mp_int_compare_zero(mp_int z)
 {
-	NRCHECK(z != NULL);
+	assert(z != NULL);
 
 	if (MP_USED(z) == 1 && z->digits[0] == 0)
+	{
 		return 0;
+	}
 	else if (MP_SIGN(z) == MP_ZPOS)
+	{
 		return 1;
+	}
 	else
+	{
 		return -1;
+	}
 }
 
-/* }}} */
-
-/* {{{ mp_int_compare_value(z, value) */
-
 int
-mp_int_compare_value(mp_int z, int value)
+mp_int_compare_value(mp_int z, mp_small value)
 {
-	mp_sign		vsign = (value < 0) ? MP_NEG : MP_ZPOS;
-	int			cmp;
+	assert(z != NULL);
 
-	CHECK(z != NULL);
+	mp_sign		vsign = (value < 0) ? MP_NEG : MP_ZPOS;
 
 	if (vsign == MP_SIGN(z))
 	{
-		cmp = s_vcmp(z, value);
+		int			cmp = s_vcmp(z, value);
 
-		if (vsign != MP_ZPOS)
-			INVERT_COMPARE_RESULT(cmp);
-		return cmp;
+		return (vsign == MP_ZPOS) ? cmp : -cmp;
 	}
 	else
 	{
-		if (value < 0)
-			return 1;
-		else
-			return -1;
+		return (value < 0) ? 1 : -1;
 	}
 }
 
-/* }}} */
+int
+mp_int_compare_uvalue(mp_int z, mp_usmall uv)
+{
+	assert(z != NULL);
 
-/* {{{ mp_int_exptmod(a, b, m, c) */
+	if (MP_SIGN(z) == MP_NEG)
+	{
+		return -1;
+	}
+	else
+	{
+		return s_uvcmp(z, uv);
+	}
+}
 
 mp_result
 mp_int_exptmod(mp_int a, mp_int b, mp_int m, mp_int c)
 {
-	mp_result	res;
-	mp_size		um;
-	mpz_t		temp[3];
-	mp_int		s;
-	int			last = 0;
-
-	CHECK(a != NULL && b != NULL && c != NULL && m != NULL);
+	assert(a != NULL && b != NULL && c != NULL && m != NULL);
 
 	/* Zero moduli and negative exponents are not considered. */
 	if (CMPZ(m) == 0)
@@ -1346,13 +1333,17 @@ mp_int_exptmod(mp_int a, mp_int b, mp_int m, mp_int c)
 	if (CMPZ(b) < 0)
 		return MP_RANGE;
 
-	um = MP_USED(m);
-	SETUP(mp_int_init_size(TEMP(0), 2 * um), last);
-	SETUP(mp_int_init_size(TEMP(1), 2 * um), last);
+	mp_size		um = MP_USED(m);
+
+	DECLARE_TEMP(3);
+	REQUIRE(GROW(TEMP(0), 2 * um));
+	REQUIRE(GROW(TEMP(1), 2 * um));
+
+	mp_int		s;
 
 	if (c == b || c == m)
 	{
-		SETUP(mp_int_init_size(TEMP(2), 2 * um), last);
+		REQUIRE(GROW(TEMP(2), 2 * um));
 		s = TEMP(2);
 	}
 	else
@@ -1360,30 +1351,17 @@ mp_int_exptmod(mp_int a, mp_int b, mp_int m, mp_int c)
 		s = c;
 	}
 
-	if ((res = mp_int_mod(a, m, TEMP(0))) != MP_OK)
-		goto CLEANUP;
-
-	if ((res = s_brmu(TEMP(1), m)) != MP_OK)
-		goto CLEANUP;
-
-	if ((res = s_embar(TEMP(0), b, m, TEMP(1), s)) != MP_OK)
-		goto CLEANUP;
-
-	res = mp_int_copy(s, c);
+	REQUIRE(mp_int_mod(a, m, TEMP(0)));
+	REQUIRE(s_brmu(TEMP(1), m));
+	REQUIRE(s_embar(TEMP(0), b, m, TEMP(1), s));
+	REQUIRE(mp_int_copy(s, c));
 
-CLEANUP:
-	while (--last >= 0)
-		mp_int_clear(TEMP(last));
-
-	return res;
+	CLEANUP_TEMP();
+	return MP_OK;
 }
 
-/* }}} */
-
-/* {{{ mp_int_exptmod_evalue(a, value, m, c) */
-
 mp_result
-mp_int_exptmod_evalue(mp_int a, int value, mp_int m, mp_int c)
+mp_int_exptmod_evalue(mp_int a, mp_small value, mp_int m, mp_int c)
 {
 	mpz_t		vtmp;
 	mp_digit	vbuf[MP_VALUE_DIGITS(value)];
@@ -1393,13 +1371,8 @@ mp_int_exptmod_evalue(mp_int a, int value, mp_int m, mp_int c)
 	return mp_int_exptmod(a, &vtmp, m, c);
 }
 
-/* }}} */
-
-/* {{{ mp_int_exptmod_bvalue(v, b, m, c) */
-
 mp_result
-mp_int_exptmod_bvalue(int value, mp_int b,
-					  mp_int m, mp_int c)
+mp_int_exptmod_bvalue(mp_small value, mp_int b, mp_int m, mp_int c)
 {
 	mpz_t		vtmp;
 	mp_digit	vbuf[MP_VALUE_DIGITS(value)];
@@ -1409,20 +1382,11 @@ mp_int_exptmod_bvalue(int value, mp_int b,
 	return mp_int_exptmod(&vtmp, b, m, c);
 }
 
-/* }}} */
-
-/* {{{ mp_int_exptmod_known(a, b, m, mu, c) */
-
 mp_result
-mp_int_exptmod_known(mp_int a, mp_int b, mp_int m, mp_int mu, mp_int c)
+mp_int_exptmod_known(mp_int a, mp_int b, mp_int m, mp_int mu,
+					 mp_int c)
 {
-	mp_result	res;
-	mp_size		um;
-	mpz_t		temp[2];
-	mp_int		s;
-	int			last = 0;
-
-	CHECK(a && b && m && c);
+	assert(a && b && m && c);
 
 	/* Zero moduli and negative exponents are not considered. */
 	if (CMPZ(m) == 0)
@@ -1430,12 +1394,16 @@ mp_int_exptmod_known(mp_int a, mp_int b, mp_int m, mp_int mu, mp_int c)
 	if (CMPZ(b) < 0)
 		return MP_RANGE;
 
-	um = MP_USED(m);
-	SETUP(mp_int_init_size(TEMP(0), 2 * um), last);
+	DECLARE_TEMP(2);
+	mp_size		um = MP_USED(m);
+
+	REQUIRE(GROW(TEMP(0), 2 * um));
+
+	mp_int		s;
 
 	if (c == b || c == m)
 	{
-		SETUP(mp_int_init_size(TEMP(1), 2 * um), last);
+		REQUIRE(GROW(TEMP(1), 2 * um));
 		s = TEMP(1);
 	}
 	else
@@ -1443,68 +1411,41 @@ mp_int_exptmod_known(mp_int a, mp_int b, mp_int m, mp_int mu, mp_int c)
 		s = c;
 	}
 
-	if ((res = mp_int_mod(a, m, TEMP(0))) != MP_OK)
-		goto CLEANUP;
-
-	if ((res = s_embar(TEMP(0), b, m, mu, s)) != MP_OK)
-		goto CLEANUP;
+	REQUIRE(mp_int_mod(a, m, TEMP(0)));
+	REQUIRE(s_embar(TEMP(0), b, m, mu, s));
+	REQUIRE(mp_int_copy(s, c));
 
-	res = mp_int_copy(s, c);
-
-CLEANUP:
-	while (--last >= 0)
-		mp_int_clear(TEMP(last));
-
-	return res;
+	CLEANUP_TEMP();
+	return MP_OK;
 }
 
-/* }}} */
-
-/* {{{ mp_int_redux_const(m, c) */
-
 mp_result
 mp_int_redux_const(mp_int m, mp_int c)
 {
-	CHECK(m != NULL && c != NULL && m != c);
+	assert(m != NULL && c != NULL && m != c);
 
 	return s_brmu(c, m);
 }
 
-/* }}} */
-
-/* {{{ mp_int_invmod(a, m, c) */
-
 mp_result
 mp_int_invmod(mp_int a, mp_int m, mp_int c)
 {
-	mp_result	res;
-	mp_sign		sa;
-	int			last = 0;
-	mpz_t		temp[2];
-
-	CHECK(a != NULL && m != NULL && c != NULL);
+	assert(a != NULL && m != NULL && c != NULL);
 
 	if (CMPZ(a) == 0 || CMPZ(m) <= 0)
 		return MP_RANGE;
 
-	sa = MP_SIGN(a);			/* need this for the result later */
+	DECLARE_TEMP(2);
 
-	for (last = 0; last < 2; ++last)
-		if ((res = mp_int_init(TEMP(last))) != MP_OK)
-			goto CLEANUP;
-
-	if ((res = mp_int_egcd(a, m, TEMP(0), TEMP(1), NULL)) != MP_OK)
-		goto CLEANUP;
+	REQUIRE(mp_int_egcd(a, m, TEMP(0), TEMP(1), NULL));
 
 	if (mp_int_compare_value(TEMP(0), 1) != 0)
 	{
-		res = MP_UNDEF;
-		goto CLEANUP;
+		REQUIRE(MP_UNDEF);
 	}
 
 	/* It is first necessary to constrain the value to the proper range */
-	if ((res = mp_int_mod(TEMP(1), m, TEMP(1))) != MP_OK)
-		goto CLEANUP;
+	REQUIRE(mp_int_mod(TEMP(1), m, TEMP(1)));
 
 	/*
 	 * Now, if 'a' was originally negative, the value we have is actually the
@@ -1512,136 +1453,112 @@ mp_int_invmod(mp_int a, mp_int m, mp_int c)
 	 * have to subtract from the modulus.  Otherwise, the value is okay as it
 	 * stands.
 	 */
-	if (sa == MP_NEG)
-		res = mp_int_sub(m, TEMP(1), c);
+	if (MP_SIGN(a) == MP_NEG)
+	{
+		REQUIRE(mp_int_sub(m, TEMP(1), c));
+	}
 	else
-		res = mp_int_copy(TEMP(1), c);
-
-CLEANUP:
-	while (--last >= 0)
-		mp_int_clear(TEMP(last));
+	{
+		REQUIRE(mp_int_copy(TEMP(1), c));
+	}
 
-	return res;
+	CLEANUP_TEMP();
+	return MP_OK;
 }
 
-/* }}} */
-
-/* {{{ mp_int_gcd(a, b, c) */
-
 /* Binary GCD algorithm due to Josef Stein, 1961 */
 mp_result
 mp_int_gcd(mp_int a, mp_int b, mp_int c)
 {
-	int			ca,
-				cb,
-				k = 0;
-	mpz_t		u,
-				v,
-				t;
-	mp_result	res;
+	assert(a != NULL && b != NULL && c != NULL);
 
-	CHECK(a != NULL && b != NULL && c != NULL);
+	int			ca = CMPZ(a);
+	int			cb = CMPZ(b);
 
-	ca = CMPZ(a);
-	cb = CMPZ(b);
 	if (ca == 0 && cb == 0)
+	{
 		return MP_UNDEF;
+	}
 	else if (ca == 0)
+	{
 		return mp_int_abs(b, c);
+	}
 	else if (cb == 0)
+	{
 		return mp_int_abs(a, c);
+	}
 
-	if ((res = mp_int_init(&t)) != MP_OK)
-		return res;
-	if ((res = mp_int_init_copy(&u, a)) != MP_OK)
-		goto U;
-	if ((res = mp_int_init_copy(&v, b)) != MP_OK)
-		goto V;
+	DECLARE_TEMP(3);
+	REQUIRE(mp_int_copy(a, TEMP(0)));
+	REQUIRE(mp_int_copy(b, TEMP(1)));
 
-	MP_SIGN(&u) = MP_ZPOS;
-	MP_SIGN(&v) = MP_ZPOS;
+	TEMP(0)->sign = MP_ZPOS;
+	TEMP(1)->sign = MP_ZPOS;
+
+	int			k = 0;
 
 	{							/* Divide out common factors of 2 from u and v */
-		int			div2_u = s_dp2k(&u),
-					div2_v = s_dp2k(&v);
+		int			div2_u = s_dp2k(TEMP(0));
+		int			div2_v = s_dp2k(TEMP(1));
 
 		k = MIN(div2_u, div2_v);
-		s_qdiv(&u, (mp_size) k);
-		s_qdiv(&v, (mp_size) k);
+		s_qdiv(TEMP(0), (mp_size) k);
+		s_qdiv(TEMP(1), (mp_size) k);
 	}
 
-	if (mp_int_is_odd(&u))
+	if (mp_int_is_odd(TEMP(0)))
 	{
-		if ((res = mp_int_neg(&v, &t)) != MP_OK)
-			goto CLEANUP;
+		REQUIRE(mp_int_neg(TEMP(1), TEMP(2)));
 	}
 	else
 	{
-		if ((res = mp_int_copy(&u, &t)) != MP_OK)
-			goto CLEANUP;
+		REQUIRE(mp_int_copy(TEMP(0), TEMP(2)));
 	}
 
 	for (;;)
 	{
-		s_qdiv(&t, s_dp2k(&t));
+		s_qdiv(TEMP(2), s_dp2k(TEMP(2)));
 
-		if (CMPZ(&t) > 0)
+		if (CMPZ(TEMP(2)) > 0)
 		{
-			if ((res = mp_int_copy(&t, &u)) != MP_OK)
-				goto CLEANUP;
+			REQUIRE(mp_int_copy(TEMP(2), TEMP(0)));
 		}
 		else
 		{
-			if ((res = mp_int_neg(&t, &v)) != MP_OK)
-				goto CLEANUP;
+			REQUIRE(mp_int_neg(TEMP(2), TEMP(1)));
 		}
 
-		if ((res = mp_int_sub(&u, &v, &t)) != MP_OK)
-			goto CLEANUP;
+		REQUIRE(mp_int_sub(TEMP(0), TEMP(1), TEMP(2)));
 
-		if (CMPZ(&t) == 0)
+		if (CMPZ(TEMP(2)) == 0)
 			break;
 	}
 
-	if ((res = mp_int_abs(&u, c)) != MP_OK)
-		goto CLEANUP;
+	REQUIRE(mp_int_abs(TEMP(0), c));
 	if (!s_qmul(c, (mp_size) k))
-		res = MP_MEMORY;
-
-CLEANUP:
-	mp_int_clear(&v);
-V:	mp_int_clear(&u);
-U:	mp_int_clear(&t);
+		REQUIRE(MP_MEMORY);
 
-	return res;
+	CLEANUP_TEMP();
+	return MP_OK;
 }
 
-/* }}} */
-
-/* {{{ mp_int_egcd(a, b, c, x, y) */
-
-/* This is the binary GCD algorithm again, but this time we keep track
-   of the elementary matrix operations as we go, so we can get values
-   x and y satisfying c = ax + by.
+/* This is the binary GCD algorithm again, but this time we keep track of the
+   elementary matrix operations as we go, so we can get values x and y
+   satisfying c = ax + by.
  */
 mp_result
-mp_int_egcd(mp_int a, mp_int b, mp_int c,
-			mp_int x, mp_int y)
-{
-	int			k,
-				last = 0,
-				ca,
-				cb;
-	mpz_t		temp[8];
-	mp_result	res;
+mp_int_egcd(mp_int a, mp_int b, mp_int c, mp_int x, mp_int y)
+{
+	assert(a != NULL && b != NULL && c != NULL && (x != NULL || y != NULL));
 
-	CHECK(a != NULL && b != NULL && c != NULL &&
-		  (x != NULL || y != NULL));
+	mp_result	res = MP_OK;
+	int			ca = CMPZ(a);
+	int			cb = CMPZ(b);
 
-	ca = CMPZ(a);
-	cb = CMPZ(b);
 	if (ca == 0 && cb == 0)
+	{
 		return MP_UNDEF;
+	}
 	else if (ca == 0)
 	{
 		if ((res = mp_int_abs(b, c)) != MP_OK)
@@ -1662,20 +1579,17 @@ mp_int_egcd(mp_int a, mp_int b, mp_int c,
 	/*
 	 * Initialize temporaries: A:0, B:1, C:2, D:3, u:4, v:5, ou:6, ov:7
 	 */
-	for (last = 0; last < 4; ++last)
-	{
-		if ((res = mp_int_init(TEMP(last))) != MP_OK)
-			goto CLEANUP;
-	}
-	TEMP(0)->digits[0] = 1;
-	TEMP(3)->digits[0] = 1;
-
-	SETUP(mp_int_init_copy(TEMP(4), a), last);
-	SETUP(mp_int_init_copy(TEMP(5), b), last);
+	DECLARE_TEMP(8);
+	REQUIRE(mp_int_set_value(TEMP(0), 1));
+	REQUIRE(mp_int_set_value(TEMP(3), 1));
+	REQUIRE(mp_int_copy(a, TEMP(4)));
+	REQUIRE(mp_int_copy(b, TEMP(5)));
 
 	/* We will work with absolute values here */
-	MP_SIGN(TEMP(4)) = MP_ZPOS;
-	MP_SIGN(TEMP(5)) = MP_ZPOS;
+	TEMP(4)->sign = MP_ZPOS;
+	TEMP(5)->sign = MP_ZPOS;
+
+	int			k = 0;
 
 	{							/* Divide out common factors of 2 from u and v */
 		int			div2_u = s_dp2k(TEMP(4)),
@@ -1686,8 +1600,8 @@ mp_int_egcd(mp_int a, mp_int b, mp_int c,
 		s_qdiv(TEMP(5), k);
 	}
 
-	SETUP(mp_int_init_copy(TEMP(6), TEMP(4)), last);
-	SETUP(mp_int_init_copy(TEMP(7), TEMP(5)), last);
+	REQUIRE(mp_int_copy(TEMP(4), TEMP(6)));
+	REQUIRE(mp_int_copy(TEMP(5), TEMP(7)));
 
 	for (;;)
 	{
@@ -1697,10 +1611,8 @@ mp_int_egcd(mp_int a, mp_int b, mp_int c,
 
 			if (mp_int_is_odd(TEMP(0)) || mp_int_is_odd(TEMP(1)))
 			{
-				if ((res = mp_int_add(TEMP(0), TEMP(7), TEMP(0))) != MP_OK)
-					goto CLEANUP;
-				if ((res = mp_int_sub(TEMP(1), TEMP(6), TEMP(1))) != MP_OK)
-					goto CLEANUP;
+				REQUIRE(mp_int_add(TEMP(0), TEMP(7), TEMP(0)));
+				REQUIRE(mp_int_sub(TEMP(1), TEMP(6), TEMP(1)));
 			}
 
 			s_qdiv(TEMP(0), 1);
@@ -1713,10 +1625,8 @@ mp_int_egcd(mp_int a, mp_int b, mp_int c,
 
 			if (mp_int_is_odd(TEMP(2)) || mp_int_is_odd(TEMP(3)))
 			{
-				if ((res = mp_int_add(TEMP(2), TEMP(7), TEMP(2))) != MP_OK)
-					goto CLEANUP;
-				if ((res = mp_int_sub(TEMP(3), TEMP(6), TEMP(3))) != MP_OK)
-					goto CLEANUP;
+				REQUIRE(mp_int_add(TEMP(2), TEMP(7), TEMP(2)));
+				REQUIRE(mp_int_sub(TEMP(3), TEMP(6), TEMP(3)));
 			}
 
 			s_qdiv(TEMP(2), 1);
@@ -1725,157 +1635,163 @@ mp_int_egcd(mp_int a, mp_int b, mp_int c,
 
 		if (mp_int_compare(TEMP(4), TEMP(5)) >= 0)
 		{
-			if ((res = mp_int_sub(TEMP(4), TEMP(5), TEMP(4))) != MP_OK)
-				goto CLEANUP;
-			if ((res = mp_int_sub(TEMP(0), TEMP(2), TEMP(0))) != MP_OK)
-				goto CLEANUP;
-			if ((res = mp_int_sub(TEMP(1), TEMP(3), TEMP(1))) != MP_OK)
-				goto CLEANUP;
+			REQUIRE(mp_int_sub(TEMP(4), TEMP(5), TEMP(4)));
+			REQUIRE(mp_int_sub(TEMP(0), TEMP(2), TEMP(0)));
+			REQUIRE(mp_int_sub(TEMP(1), TEMP(3), TEMP(1)));
 		}
 		else
 		{
-			if ((res = mp_int_sub(TEMP(5), TEMP(4), TEMP(5))) != MP_OK)
-				goto CLEANUP;
-			if ((res = mp_int_sub(TEMP(2), TEMP(0), TEMP(2))) != MP_OK)
-				goto CLEANUP;
-			if ((res = mp_int_sub(TEMP(3), TEMP(1), TEMP(3))) != MP_OK)
-				goto CLEANUP;
+			REQUIRE(mp_int_sub(TEMP(5), TEMP(4), TEMP(5)));
+			REQUIRE(mp_int_sub(TEMP(2), TEMP(0), TEMP(2)));
+			REQUIRE(mp_int_sub(TEMP(3), TEMP(1), TEMP(3)));
 		}
 
 		if (CMPZ(TEMP(4)) == 0)
 		{
-			if (x && (res = mp_int_copy(TEMP(2), x)) != MP_OK)
-				goto CLEANUP;
-			if (y && (res = mp_int_copy(TEMP(3), y)) != MP_OK)
-				goto CLEANUP;
+			if (x)
+				REQUIRE(mp_int_copy(TEMP(2), x));
+			if (y)
+				REQUIRE(mp_int_copy(TEMP(3), y));
 			if (c)
 			{
 				if (!s_qmul(TEMP(5), k))
 				{
-					res = MP_MEMORY;
-					goto CLEANUP;
+					REQUIRE(MP_MEMORY);
 				}
-
-				res = mp_int_copy(TEMP(5), c);
+				REQUIRE(mp_int_copy(TEMP(5), c));
 			}
 
 			break;
 		}
 	}
 
-CLEANUP:
-	while (--last >= 0)
-		mp_int_clear(TEMP(last));
-
-	return res;
+	CLEANUP_TEMP();
+	return MP_OK;
 }
 
-/* }}} */
+mp_result
+mp_int_lcm(mp_int a, mp_int b, mp_int c)
+{
+	assert(a != NULL && b != NULL && c != NULL);
+
+	/*
+	 * Since a * b = gcd(a, b) * lcm(a, b), we can compute lcm(a, b) = (a /
+	 * gcd(a, b)) * b.
+	 *
+	 * This formulation insures everything works even if the input variables
+	 * share space.
+	 */
+	DECLARE_TEMP(1);
+	REQUIRE(mp_int_gcd(a, b, TEMP(0)));
+	REQUIRE(mp_int_div(a, TEMP(0), TEMP(0), NULL));
+	REQUIRE(mp_int_mul(TEMP(0), b, TEMP(0)));
+	REQUIRE(mp_int_copy(TEMP(0), c));
 
-/* {{{ mp_int_divisible_value(a, v) */
+	CLEANUP_TEMP();
+	return MP_OK;
+}
 
-int
-mp_int_divisible_value(mp_int a, int v)
+bool
+mp_int_divisible_value(mp_int a, mp_small v)
 {
-	int			rem = 0;
+	mp_small	rem = 0;
 
 	if (mp_int_div_value(a, v, NULL, &rem) != MP_OK)
-		return 0;
-
+	{
+		return false;
+	}
 	return rem == 0;
 }
 
-/* }}} */
-
-/* {{{ mp_int_is_pow2(z) */
-
 int
 mp_int_is_pow2(mp_int z)
 {
-	CHECK(z != NULL);
+	assert(z != NULL);
 
 	return s_isp2(z);
 }
 
-/* }}} */
-
-/* {{{ mp_int_sqrt(a, c) */
-
+/* Implementation of Newton's root finding method, based loosely on a patch
+   contributed by Hal Finkel <half@halssoftware.com>
+   modified by M. J. Fromberger.
+ */
 mp_result
-mp_int_sqrt(mp_int a, mp_int c)
+mp_int_root(mp_int a, mp_small b, mp_int c)
 {
-	mp_result	res = MP_OK;
-	mpz_t		temp[2];
-	int			last = 0;
+	assert(a != NULL && c != NULL && b > 0);
 
-	CHECK(a != NULL && c != NULL);
+	if (b == 1)
+	{
+		return mp_int_copy(a, c);
+	}
+	bool		flips = false;
 
-	/* The square root of a negative value does not exist in the integers. */
 	if (MP_SIGN(a) == MP_NEG)
-		return MP_UNDEF;
+	{
+		if (b % 2 == 0)
+		{
+			return MP_UNDEF;	/* root does not exist for negative a with
+								 * even b */
+		}
+		else
+		{
+			flips = true;
+		}
+	}
 
-	SETUP(mp_int_init_copy(TEMP(last), a), last);
-	SETUP(mp_int_init(TEMP(last)), last);
+	DECLARE_TEMP(5);
+	REQUIRE(mp_int_copy(a, TEMP(0)));
+	REQUIRE(mp_int_copy(a, TEMP(1)));
+	TEMP(0)->sign = MP_ZPOS;
+	TEMP(1)->sign = MP_ZPOS;
 
 	for (;;)
 	{
-		if ((res = mp_int_sqr(TEMP(0), TEMP(1))) != MP_OK)
-			goto CLEANUP;
+		REQUIRE(mp_int_expt(TEMP(1), b, TEMP(2)));
 
-		if (mp_int_compare_unsigned(a, TEMP(1)) == 0)
+		if (mp_int_compare_unsigned(TEMP(2), TEMP(0)) <= 0)
 			break;
 
-		if ((res = mp_int_copy(a, TEMP(1))) != MP_OK)
-			goto CLEANUP;
-		if ((res = mp_int_div(TEMP(1), TEMP(0), TEMP(1), NULL)) != MP_OK)
-			goto CLEANUP;
-		if ((res = mp_int_add(TEMP(0), TEMP(1), TEMP(1))) != MP_OK)
-			goto CLEANUP;
-		if ((res = mp_int_div_pow2(TEMP(1), 1, TEMP(1), NULL)) != MP_OK)
-			goto CLEANUP;
+		REQUIRE(mp_int_sub(TEMP(2), TEMP(0), TEMP(2)));
+		REQUIRE(mp_int_expt(TEMP(1), b - 1, TEMP(3)));
+		REQUIRE(mp_int_mul_value(TEMP(3), b, TEMP(3)));
+		REQUIRE(mp_int_div(TEMP(2), TEMP(3), TEMP(4), NULL));
+		REQUIRE(mp_int_sub(TEMP(1), TEMP(4), TEMP(4)));
 
-		if (mp_int_compare_unsigned(TEMP(0), TEMP(1)) == 0)
-			break;
-		if ((res = mp_int_sub_value(TEMP(0), 1, TEMP(0))) != MP_OK)
-			goto CLEANUP;
-		if (mp_int_compare_unsigned(TEMP(0), TEMP(1)) == 0)
-			break;
-
-		if ((res = mp_int_copy(TEMP(1), TEMP(0))) != MP_OK)
-			goto CLEANUP;
+		if (mp_int_compare_unsigned(TEMP(1), TEMP(4)) == 0)
+		{
+			REQUIRE(mp_int_sub_value(TEMP(4), 1, TEMP(4)));
+		}
+		REQUIRE(mp_int_copy(TEMP(4), TEMP(1)));
 	}
 
-	res = mp_int_copy(TEMP(0), c);
+	REQUIRE(mp_int_copy(TEMP(1), c));
 
-CLEANUP:
-	while (--last >= 0)
-		mp_int_clear(TEMP(last));
+	/* If the original value of a was negative, flip the output sign. */
+	if (flips)
+		(void) mp_int_neg(c, c);	/* cannot fail */
 
-	return res;
+	CLEANUP_TEMP();
+	return MP_OK;
 }
 
-/* }}} */
-
-/* {{{ mp_int_to_int(z, out) */
-
 mp_result
-mp_int_to_int(mp_int z, int *out)
+mp_int_to_int(mp_int z, mp_small * out)
 {
-	unsigned int uv = 0;
-	mp_size		uz;
-	mp_digit   *dz;
-	mp_sign		sz;
+	assert(z != NULL);
 
-	CHECK(z != NULL);
+	/* Make sure the value is representable as a small integer */
+	mp_sign		sz = MP_SIGN(z);
 
-	/* Make sure the value is representable as an int */
-	sz = MP_SIGN(z);
-	if ((sz == MP_ZPOS && mp_int_compare_value(z, INT_MAX) > 0) ||
-		mp_int_compare_value(z, INT_MIN) < 0)
+	if ((sz == MP_ZPOS && mp_int_compare_value(z, MP_SMALL_MAX) > 0) ||
+		mp_int_compare_value(z, MP_SMALL_MIN) < 0)
+	{
 		return MP_RANGE;
+	}
 
-	uz = MP_USED(z);
-	dz = MP_DIGITS(z) + uz - 1;
+	mp_usmall	uz = MP_USED(z);
+	mp_digit   *dz = MP_DIGITS(z) + uz - 1;
+	mp_small	uv = 0;
 
 	while (uz > 0)
 	{
@@ -1885,33 +1801,56 @@ mp_int_to_int(mp_int z, int *out)
 	}
 
 	if (out)
-		*out = (sz == MP_NEG) ? -(int) uv : (int) uv;
+		*out = (mp_small) ((sz == MP_NEG) ? -uv : uv);
 
 	return MP_OK;
 }
 
-/* }}} */
-
-/* {{{ mp_int_to_string(z, radix, str, limit) */
-
 mp_result
-mp_int_to_string(mp_int z, mp_size radix,
-				 char *str, int limit)
+mp_int_to_uint(mp_int z, mp_usmall * out)
 {
-	mp_result	res;
-	int			cmp = 0;
+	assert(z != NULL);
 
-	CHECK(z != NULL && str != NULL && limit >= 2);
+	/* Make sure the value is representable as an unsigned small integer */
+	mp_size		sz = MP_SIGN(z);
 
-	if (radix < MP_MIN_RADIX || radix > MP_MAX_RADIX)
+	if (sz == MP_NEG || mp_int_compare_uvalue(z, MP_USMALL_MAX) > 0)
+	{
 		return MP_RANGE;
+	}
+
+	mp_size		uz = MP_USED(z);
+	mp_digit   *dz = MP_DIGITS(z) + uz - 1;
+	mp_usmall	uv = 0;
+
+	while (uz > 0)
+	{
+		uv <<= MP_DIGIT_BIT / 2;
+		uv = (uv << (MP_DIGIT_BIT / 2)) | *dz--;
+		--uz;
+	}
+
+	if (out)
+		*out = uv;
+
+	return MP_OK;
+}
+
+mp_result
+mp_int_to_string(mp_int z, mp_size radix, char *str, int limit)
+{
+	assert(z != NULL && str != NULL && limit >= 2);
+	assert(radix >= MP_MIN_RADIX && radix <= MP_MAX_RADIX);
+
+	int			cmp = 0;
 
 	if (CMPZ(z) == 0)
 	{
-		*str++ = s_val2ch(0, mp_flags & MP_CAP_DIGITS);
+		*str++ = s_val2ch(0, 1);
 	}
 	else
 	{
+		mp_result	res;
 		mpz_t		tmp;
 		char	   *h,
 				   *t;
@@ -1935,7 +1874,7 @@ mp_int_to_string(mp_int z, mp_size radix,
 				break;
 
 			d = s_ddiv(&tmp, (mp_digit) radix);
-			*str++ = s_val2ch(d, mp_flags & MP_CAP_DIGITS);
+			*str++ = s_val2ch(d, 1);
 		}
 		t = str - 1;
 
@@ -1953,26 +1892,22 @@ mp_int_to_string(mp_int z, mp_size radix,
 
 	*str = '\0';
 	if (cmp == 0)
+	{
 		return MP_OK;
+	}
 	else
+	{
 		return MP_TRUNC;
+	}
 }
 
-/* }}} */
-
-/* {{{ mp_int_string_len(z, radix) */
-
 mp_result
 mp_int_string_len(mp_int z, mp_size radix)
 {
-	int			len;
-
-	CHECK(z != NULL);
-
-	if (radix < MP_MIN_RADIX || radix > MP_MAX_RADIX)
-		return MP_RANGE;
+	assert(z != NULL);
+	assert(radix >= MP_MIN_RADIX && radix <= MP_MAX_RADIX);
 
-	len = s_outlen(z, radix) + 1;	/* for terminator */
+	int			len = s_outlen(z, radix) + 1;	/* for terminator */
 
 	/* Allow for sign marker on negatives */
 	if (MP_SIGN(z) == MP_NEG)
@@ -1981,31 +1916,19 @@ mp_int_string_len(mp_int z, mp_size radix)
 	return len;
 }
 
-/* }}} */
-
-/* {{{ mp_int_read_string(z, radix, *str) */
-
 /* Read zero-terminated string into z */
 mp_result
 mp_int_read_string(mp_int z, mp_size radix, const char *str)
 {
 	return mp_int_read_cstring(z, radix, str, NULL);
-
 }
 
-/* }}} */
-
-/* {{{ mp_int_read_cstring(z, radix, *str, **end) */
-
 mp_result
-mp_int_read_cstring(mp_int z, mp_size radix, const char *str, char **end)
+mp_int_read_cstring(mp_int z, mp_size radix, const char *str,
+					char **end)
 {
-	int			ch;
-
-	CHECK(z != NULL && str != NULL);
-
-	if (radix < MP_MIN_RADIX || radix > MP_MAX_RADIX)
-		return MP_RANGE;
+	assert(z != NULL && str != NULL);
+	assert(radix >= MP_MIN_RADIX && radix <= MP_MAX_RADIX);
 
 	/* Skip leading whitespace */
 	while (isspace((unsigned char) *str))
@@ -2015,17 +1938,19 @@ mp_int_read_cstring(mp_int z, mp_size radix, const char *str, char **end)
 	switch (*str)
 	{
 		case '-':
-			MP_SIGN(z) = MP_NEG;
+			z->sign = MP_NEG;
 			++str;
 			break;
 		case '+':
 			++str;				/* fallthrough */
 		default:
-			MP_SIGN(z) = MP_ZPOS;
+			z->sign = MP_ZPOS;
 			break;
 	}
 
 	/* Skip leading zeroes */
+	int			ch;
+
 	while ((ch = s_ch2val(*str, radix)) == 0)
 		++str;
 
@@ -2033,7 +1958,7 @@ mp_int_read_cstring(mp_int z, mp_size radix, const char *str, char **end)
 	if (!s_pad(z, s_inlen(strlen(str), radix)))
 		return MP_MEMORY;
 
-	MP_USED(z) = 1;
+	z->used = 1;
 	z->digits[0] = 0;
 
 	while (*str != '\0' && ((ch = s_ch2val(*str, radix)) >= 0))
